unit fMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Contnrs, StdCtrls;

type

  TPessoa = class
  private
    fNome: string;
  public
    property Nome: string read fNome write fNome;
  end;

  TfrmMain = class(TForm)
    btnPilha: TButton;
    btnFila: TButton;
    btnLista: TButton;
    procedure btnPilhaClick(Sender: TObject);
    procedure btnFilaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnListaClick(Sender: TObject);
  private
    fPessoa1, fPessoa2, fPessoa3, fPessoa4, fPessoa5: TPessoa;
  public

  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.btnPilhaClick(Sender: TObject);
var
  vPilha: TStack;
begin
  vPilha := TStack.Create;{LINHA A}
  try
    vPilha.Push(fPessoa1);{LINHA B}
    vPilha.Push(fPessoa5);{LINHA C}
    ShowMessage(TPessoa(vPilha.Pop).Nome);{LINHA D}
    vPilha.Push(fPessoa2);{LINHA E}
    ShowMessage(TPessoa(vPilha.Peek).Nome);{LINHA F}
    ShowMessage(TPessoa(vPilha.Pop).Nome);{LINHA G}
    vPilha.Push(fPessoa4);{LINHA H}
    vPilha.Push(fPessoa3);{LINHA I}
    ShowMessage(TPessoa(vPilha.Pop).Nome);{LINHA J}
    ShowMessage(TPessoa(vPilha.Pop).Nome);{LINHA K}
    ShowMessage(TPessoa(vPilha.Pop).Nome);{LINHA L}
  finally
    vPilha.Free;
  end;
end;

procedure TfrmMain.btnFilaClick(Sender: TObject);
var
  vFila: TQueue;
begin
  vFila := TQueue.Create;{LINHA A}
  try
    vFila.Push(fPessoa1);{LINHA B}
    vFila.Push(fPessoa5);{LINHA C}
    ShowMessage(TPessoa(vFila.Pop).Nome);{LINHA D}
    vFila.Push(fPessoa2);{LINHA E}
    ShowMessage(TPessoa(vFila.Peek).Nome);{LINHA F}
    ShowMessage(TPessoa(vFila.Pop).Nome);{LINHA G}
    vFila.Push(fPessoa4);{LINHA H}
    vFila.Push(fPessoa3);{LINHA I}
    ShowMessage(TPessoa(vFila.Pop).Nome);{LINHA J}
    ShowMessage(TPessoa(vFila.Pop).Nome);{LINHA K}
    ShowMessage(TPessoa(vFila.Pop).Nome);{LINHA L}
  finally
    vFila.Free;
  end;
end;

procedure TfrmMain.btnListaClick(Sender: TObject);
var
  vLista: TList;
begin
  vLista := TList.Create;{LINHA A}
  try
    vLista.Add(fPessoa1);{LINHA B}
    vLista.Add(fPessoa5);{LINHA C}
    vLista.Add(fPessoa2);{LINHA D}
    vLista.Add(fPessoa4);{LINHA E}
    ShowMessage(TPessoa(vLista.Items[2]).Nome);{LINHA F}
    vLista.Delete(2);{LINHA G}
    vLista.Insert(0, fPessoa3);{LINHA H}
    ShowMessage(TPessoa(vLista.Items[0]).Nome);
    ShowMessage(TPessoa(vLista.Items[1]).Nome);
    ShowMessage(TPessoa(vLista.Items[2]).Nome);
    ShowMessage(TPessoa(vLista.Items[3]).Nome);
  finally
    vLista.Free;
  end;
end;



procedure TfrmMain.FormCreate(Sender: TObject);
begin
  fPessoa1 := TPessoa.Create;
  fPessoa1.Nome := 'Gustavo';

  fPessoa2 := TPessoa.Create;
  fPessoa2.Nome := 'Dbora';

  fPessoa3 := TPessoa.Create;
  fPessoa3.Nome := 'Felipe';

  fPessoa4 := TPessoa.Create;
  fPessoa4.Nome := 'Tom';

  fPessoa5 := TPessoa.Create;
  fPessoa5.Nome := 'Carlos';
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  fPessoa1.Free;
  fPessoa2.Free;
  fPessoa3.Free;
  fPessoa4.Free;
  fPessoa5.Free;
end;

end.
